diff -ruN vdr-1.7.23/PLUGINS/src/dvbhddevice/setup.c vdr-1.7.24/PLUGINS/src/dvbhddevice/setup.c
--- vdr-1.7.23/PLUGINS/src/dvbhddevice/setup.c	2011-12-04 16:31:58.000000000 +0100
+++ vdr-1.7.24/PLUGINS/src/dvbhddevice/setup.c	2012-02-08 16:14:01.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: setup.c 1.14 2011/12/04 15:31:58 kls Exp $
+ * $Id: setup.c 1.17 2012/02/08 15:14:01 kls Exp $
  */
 
 #include "setup.h"
@@ -28,10 +28,13 @@
     AudioDownmix = HDFF_AUDIO_DOWNMIX_AUTOMATIC;
     OsdSize = 0;
     CecEnabled = 1;
+    CecTvOn = 1;
+    CecTvOff = 0;
     RemoteProtocol = 1;
     RemoteAddress = -1;
     HighLevelOsd = 1;
     TrueColorOsd = 1;
+    HideMainMenu = 0;
 }
 
 bool cHdffSetup::SetupParse(const char *Name, const char *Value)
@@ -45,10 +48,13 @@
     else if (strcmp(Name, "AudioDownmix")      == 0) AudioDownmix      = atoi(Value);
     else if (strcmp(Name, "OsdSize")           == 0) OsdSize           = atoi(Value);
     else if (strcmp(Name, "CecEnabled")        == 0) CecEnabled        = atoi(Value);
+    else if (strcmp(Name, "CecTvOn")           == 0) CecTvOn           = atoi(Value);
+    else if (strcmp(Name, "CecTvOff")          == 0) CecTvOff          = atoi(Value);
     else if (strcmp(Name, "RemoteProtocol")    == 0) RemoteProtocol    = atoi(Value);
     else if (strcmp(Name, "RemoteAddress")     == 0) RemoteAddress     = atoi(Value);
     else if (strcmp(Name, "HighLevelOsd")      == 0) HighLevelOsd      = atoi(Value);
     else if (strcmp(Name, "TrueColorOsd")      == 0) TrueColorOsd      = atoi(Value);
+    else if (strcmp(Name, "HideMainMenu")      == 0) HideMainMenu      = atoi(Value);
     else return false;
     return true;
 }
@@ -112,12 +118,74 @@
     }
 }
 
+void cHdffSetup::SetNextVideoConversion(void)
+{
+    int nextVideoConversion = HDFF_VIDEO_CONVERSION_AUTOMATIC;
+
+    if (TvFormat == HDFF_TV_FORMAT_16_BY_9)
+    {
+        switch (VideoConversion)
+        {
+            case HDFF_VIDEO_CONVERSION_PILLARBOX:
+                nextVideoConversion = HDFF_VIDEO_CONVERSION_CENTRE_CUT_OUT;
+                break;
+            case HDFF_VIDEO_CONVERSION_CENTRE_CUT_OUT:
+                nextVideoConversion = HDFF_VIDEO_CONVERSION_ALWAYS_16_BY_9;
+                break;
+            case HDFF_VIDEO_CONVERSION_ALWAYS_16_BY_9:
+                nextVideoConversion = HDFF_VIDEO_CONVERSION_ZOOM_16_BY_9;
+                break;
+            case HDFF_VIDEO_CONVERSION_ZOOM_16_BY_9:
+                nextVideoConversion = HDFF_VIDEO_CONVERSION_PILLARBOX;
+                break;
+        }
+    }
+    else
+    {
+        switch (VideoConversion)
+        {
+            case HDFF_VIDEO_CONVERSION_LETTERBOX_16_BY_9:
+                nextVideoConversion = HDFF_VIDEO_CONVERSION_LETTERBOX_14_BY_9;
+                break;
+            case HDFF_VIDEO_CONVERSION_LETTERBOX_14_BY_9:
+                nextVideoConversion = HDFF_VIDEO_CONVERSION_CENTRE_CUT_OUT;
+                break;
+            case HDFF_VIDEO_CONVERSION_CENTRE_CUT_OUT:
+                nextVideoConversion = HDFF_VIDEO_CONVERSION_LETTERBOX_16_BY_9;
+                break;
+        }
+    }
+    VideoConversion = nextVideoConversion;
+}
+
+const char * cHdffSetup::GetVideoConversionString(void)
+{
+    switch (VideoConversion)
+    {
+        case HDFF_VIDEO_CONVERSION_AUTOMATIC:
+        default:
+            return tr("Automatic");
+        case HDFF_VIDEO_CONVERSION_LETTERBOX_16_BY_9:
+            return tr("Letterbox 16/9");
+        case HDFF_VIDEO_CONVERSION_LETTERBOX_14_BY_9:
+            return tr("Letterbox 14/9");
+        case HDFF_VIDEO_CONVERSION_PILLARBOX:
+            return tr("Pillarbox");
+        case HDFF_VIDEO_CONVERSION_CENTRE_CUT_OUT:
+            return tr("CentreCutOut");
+        case HDFF_VIDEO_CONVERSION_ALWAYS_16_BY_9:
+            return tr("Always 16/9");
+        case HDFF_VIDEO_CONVERSION_ZOOM_16_BY_9:
+            return tr("Zoom 16/9");
+    }
+}
+
+
 cHdffSetupPage::cHdffSetupPage(HDFF::cHdffCmdIf * pHdffCmdIf)
 {
     const int kResolutions = 4;
     const int kVideoModeAdaptions = 4;
     const int kTvFormats = 2;
-    const int kVideoConversions = 6;
     const int kAnalogueVideos = 4;
     const int kAudioDownmixes = 5;
     const int kOsdSizes = 5;
@@ -145,17 +213,6 @@
         "16/9",
     };
 
-    static const char * VideoConversionItems[kVideoConversions] =
-    {
-        tr("Automatic"),
-        tr("Letterbox 16/9"),
-        tr("Letterbox 14/9"),
-        tr("Pillarbox"),
-        tr("CentreCutOut"),
-        tr("Always 16/9"),
-    };
-
-
     static const char * AnalogueVideoItems[kAnalogueVideos] =
     {
         tr("Disabled"),
@@ -194,25 +251,133 @@
 
     Add(new cMenuEditStraItem(tr("Resolution"), &mNewHdffSetup.Resolution, kResolutions, ResolutionItems));
     Add(new cMenuEditStraItem(tr("Video Mode Adaption"), &mNewHdffSetup.VideoModeAdaption, kVideoModeAdaptions, VideoModeAdaptionItems));
-    Add(new cMenuEditStraItem(tr("TV format"), &mNewHdffSetup.TvFormat, kTvFormats, TvFormatItems));
-    Add(new cMenuEditStraItem(tr("Video Conversion"), &mNewHdffSetup.VideoConversion, kVideoConversions, VideoConversionItems));
+    mTvFormatItem = new cMenuEditStraItem(tr("TV format"), &mNewHdffSetup.TvFormat, kTvFormats, TvFormatItems);
+    Add(mTvFormatItem);
     Add(new cMenuEditStraItem(tr("Analogue Video"), &mNewHdffSetup.AnalogueVideo, kAnalogueVideos, AnalogueVideoItems));
     Add(new cMenuEditIntItem(tr("Audio Delay (ms)"), &mNewHdffSetup.AudioDelay, 0, 500));
     Add(new cMenuEditStraItem(tr("Audio Downmix"), &mNewHdffSetup.AudioDownmix, kAudioDownmixes, AudioDownmixItems));
     Add(new cMenuEditStraItem(tr("OSD Size"), &mNewHdffSetup.OsdSize, kOsdSizes, OsdSizeItems));
     Add(new cMenuEditBoolItem(tr("HDMI CEC"), &mNewHdffSetup.CecEnabled));
+    Add(new cMenuEditBoolItem(tr("CEC: Switch TV on"), &mNewHdffSetup.CecTvOn));
+    Add(new cMenuEditBoolItem(tr("CEC: Switch TV off"), &mNewHdffSetup.CecTvOff));
     Add(new cMenuEditStraItem(tr("Remote Control Protocol"), &mNewHdffSetup.RemoteProtocol, kRemoteProtocols, RemoteProtocolItems));
     Add(new cMenuEditIntItem(tr("Remote Control Address"), &mNewHdffSetup.RemoteAddress, -1, 31));
     Add(new cMenuEditBoolItem(tr("High Level OSD"), &mNewHdffSetup.HighLevelOsd));
     Add(new cMenuEditBoolItem(tr("Allow True Color OSD"), &mNewHdffSetup.TrueColorOsd));
+    Add(new cMenuEditBoolItem(tr("Hide mainmenu entry"), &mNewHdffSetup.HideMainMenu));
+
+    mVideoConversion = 0;
+    if (mNewHdffSetup.TvFormat == HDFF_TV_FORMAT_16_BY_9)
+    {
+        switch (mNewHdffSetup.VideoConversion)
+        {
+            case HDFF_VIDEO_CONVERSION_PILLARBOX:
+                mVideoConversion = 0;
+                break;
+            case HDFF_VIDEO_CONVERSION_CENTRE_CUT_OUT:
+                mVideoConversion = 1;
+                break;
+            case HDFF_VIDEO_CONVERSION_ALWAYS_16_BY_9:
+                mVideoConversion = 2;
+                break;
+            case HDFF_VIDEO_CONVERSION_ZOOM_16_BY_9:
+                mVideoConversion = 3;
+                break;
+        }
+    }
+    else
+    {
+        switch (mNewHdffSetup.VideoConversion)
+        {
+            case HDFF_VIDEO_CONVERSION_LETTERBOX_16_BY_9:
+                mVideoConversion = 0;
+                break;
+            case HDFF_VIDEO_CONVERSION_LETTERBOX_14_BY_9:
+                mVideoConversion = 1;
+                break;
+            case HDFF_VIDEO_CONVERSION_CENTRE_CUT_OUT:
+                mVideoConversion = 2;
+                break;
+        }
+    }
+    BuildVideoConversionItem();
 }
 
 cHdffSetupPage::~cHdffSetupPage(void)
 {
 }
 
+void cHdffSetupPage::BuildVideoConversionItem(void)
+{
+    const int kVideoConversions4by3 = 3;
+    const int kVideoConversions16by9 = 4;
+
+    static const char * VideoConversionItems4by3[kVideoConversions4by3] =
+    {
+        tr("Letterbox 16/9"),
+        tr("Letterbox 14/9"),
+        tr("CentreCutOut")
+    };
+
+    static const char * VideoConversionItems16by9[kVideoConversions16by9] =
+    {
+        tr("Pillarbox"),
+        tr("CentreCutOut"),
+        tr("Always 16/9"),
+        tr("Zoom 16/9")
+    };
+
+    cOsdItem * item;
+
+    cList<cOsdItem>::Del(mTvFormatItem->Next());
+    if (mNewHdffSetup.TvFormat == HDFF_TV_FORMAT_16_BY_9)
+    {
+        item = new cMenuEditStraItem(tr("Video Conversion"), &mVideoConversion,
+                kVideoConversions16by9, VideoConversionItems16by9);
+    }
+    else
+    {
+        item = new cMenuEditStraItem(tr("Video Conversion"), &mVideoConversion,
+                kVideoConversions4by3, VideoConversionItems4by3);
+    }
+    Add(item, false, mTvFormatItem);
+}
+
 void cHdffSetupPage::Store(void)
 {
+    if (mNewHdffSetup.TvFormat == HDFF_TV_FORMAT_16_BY_9)
+    {
+        switch (mVideoConversion)
+        {
+            case 0:
+                mNewHdffSetup.VideoConversion = HDFF_VIDEO_CONVERSION_PILLARBOX;
+                break;
+            case 1:
+                mNewHdffSetup.VideoConversion = HDFF_VIDEO_CONVERSION_CENTRE_CUT_OUT;
+                break;
+            case 2:
+                mNewHdffSetup.VideoConversion = HDFF_VIDEO_CONVERSION_ALWAYS_16_BY_9;
+                break;
+            case 3:
+                mNewHdffSetup.VideoConversion = HDFF_VIDEO_CONVERSION_ZOOM_16_BY_9;
+                break;
+        }
+    }
+    else
+    {
+        switch (mVideoConversion)
+        {
+            case 0:
+                mNewHdffSetup.VideoConversion = HDFF_VIDEO_CONVERSION_LETTERBOX_16_BY_9;
+                break;
+            case 1:
+                mNewHdffSetup.VideoConversion = HDFF_VIDEO_CONVERSION_LETTERBOX_14_BY_9;
+                break;
+            case 2:
+                mNewHdffSetup.VideoConversion = HDFF_VIDEO_CONVERSION_CENTRE_CUT_OUT;
+                break;
+        }
+    }
     SetupStore("Resolution", mNewHdffSetup.Resolution);
     SetupStore("VideoModeAdaption", mNewHdffSetup.VideoModeAdaption);
     SetupStore("TvFormat", mNewHdffSetup.TvFormat);
@@ -222,10 +387,13 @@
     SetupStore("AudioDownmix", mNewHdffSetup.AudioDownmix);
     SetupStore("OsdSize", mNewHdffSetup.OsdSize);
     SetupStore("CecEnabled", mNewHdffSetup.CecEnabled);
+    SetupStore("CecTvOn", mNewHdffSetup.CecTvOn);
+    SetupStore("CecTvOff", mNewHdffSetup.CecTvOff);
     SetupStore("RemoteProtocol", mNewHdffSetup.RemoteProtocol);
     SetupStore("RemoteAddress", mNewHdffSetup.RemoteAddress);
     SetupStore("HighLevelOsd", mNewHdffSetup.HighLevelOsd);
     SetupStore("TrueColorOsd", mNewHdffSetup.TrueColorOsd);
+    SetupStore("HideMainMenu", mNewHdffSetup.HideMainMenu);
 
     if (mHdffCmdIf)
     {
@@ -237,7 +405,7 @@
         HdffHdmiConfig_t hdmiConfig;
 
         videoFormat.AutomaticEnabled = true;
-        videoFormat.AfdEnabled = true;
+        videoFormat.AfdEnabled = false;
         videoFormat.TvFormat = (HdffTvFormat_t) mNewHdffSetup.TvFormat;
         videoFormat.VideoConversion = (HdffVideoConversion_t) mNewHdffSetup.VideoConversion;
         mHdffCmdIf->CmdAvSetVideoFormat(0, &videoFormat);
@@ -247,6 +415,7 @@
 
         mHdffCmdIf->CmdMuxSetVideoOut((HdffVideoOut_t) mNewHdffSetup.AnalogueVideo);
 
+        memset(&hdmiConfig, 0, sizeof(hdmiConfig));
         hdmiConfig.TransmitAudio = true;
         hdmiConfig.ForceDviMode = false;
         hdmiConfig.CecEnabled = mNewHdffSetup.CecEnabled;
@@ -259,3 +428,29 @@
 
     gHdffSetup = mNewHdffSetup;
 }
+
+eOSState cHdffSetupPage::ProcessKey(eKeys key)
+{
+	eOSState state = cMenuSetupPage::ProcessKey(key);
+
+	if (state == osContinue)
+	{
+		cOsdItem * item;
+		switch (key)
+		{
+			case kLeft:
+			case kRight:
+				item = Get(Current());
+				if (item == mTvFormatItem)
+				{
+				    mVideoConversion = 0;
+					BuildVideoConversionItem();
+					Display();
+				}
+				break;
+			default:
+				break;
+		}
+	}
+	return state;
+}
diff -ruN vdr-1.7.23/PLUGINS/src/dvbhddevice/setup.h vdr-1.7.24/PLUGINS/src/dvbhddevice/setup.h
--- vdr-1.7.23/PLUGINS/src/dvbhddevice/setup.h	2011-12-04 16:32:13.000000000 +0100
+++ vdr-1.7.24/PLUGINS/src/dvbhddevice/setup.h	2012-02-08 16:14:56.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: setup.h 1.10 2011/12/04 15:32:13 kls Exp $
+ * $Id: setup.h 1.12 2012/02/08 15:14:56 kls Exp $
  */
 
 #ifndef _HDFF_SETUP_H_
@@ -18,6 +18,8 @@
     bool SetupParse(const char * Name, const char * Value);
     void GetOsdSize(int &Width, int &Height, double &PixelAspect);
     HdffVideoMode_t GetVideoMode(void);
+    void SetNextVideoConversion(void);
+    const char * GetVideoConversionString(void);
 
     int Resolution;
     int VideoModeAdaption;
@@ -28,11 +30,15 @@
     int AudioDownmix;
     int OsdSize;
     int CecEnabled;
+    int CecTvOn;
+    int CecTvOff;
     int RemoteProtocol;
     int RemoteAddress;
 
     int HighLevelOsd;
     int TrueColorOsd;
+
+    int HideMainMenu;
 };
 
 extern cHdffSetup gHdffSetup;
@@ -42,6 +48,10 @@
 private:
     HDFF::cHdffCmdIf * mHdffCmdIf;
     cHdffSetup mNewHdffSetup;
+    cOsdItem * mTvFormatItem;
+    int mVideoConversion;
+
+    void BuildVideoConversionItem(void);
 
 protected:
     virtual void Store(void);
@@ -49,6 +59,7 @@
 public:
     cHdffSetupPage(HDFF::cHdffCmdIf * pHdffCmdIf);
     virtual ~cHdffSetupPage(void);
+    virtual eOSState ProcessKey(eKeys Key);
 };
 
 #endif
diff -ruN vdr-1.7.23/PLUGINS/src/dvbsddevice/Makefile vdr-1.7.24/PLUGINS/src/dvbsddevice/Makefile
--- vdr-1.7.23/PLUGINS/src/dvbsddevice/Makefile	2011-05-21 14:25:37.000000000 +0200
+++ vdr-1.7.24/PLUGINS/src/dvbsddevice/Makefile	2012-01-18 13:28:43.000000000 +0100
@@ -1,7 +1,7 @@
 #
 # Makefile for a Video Disk Recorder plugin
 #
-# $Id: Makefile 1.7 2011/05/21 12:25:37 kls Exp $
+# $Id: Makefile 1.8 2012/01/18 12:28:43 kls Exp $
 
 # The official name of this plugin.
 # This name will be used in the '-P...' option of VDR to load the plugin.
@@ -22,9 +22,9 @@
 
 ### The directory environment:
 
-VDRDIR = ../../..
-LIBDIR = ../../lib
-TMPDIR = /tmp
+VDRDIR ?= ../../..
+LIBDIR ?= ../../lib
+TMPDIR ?= /tmp
 
 ### Make sure that necessary options are included:
 
diff -ruN vdr-1.7.23/PLUGINS/src/dvbsddevice/dvbsdffdevice.c vdr-1.7.24/PLUGINS/src/dvbsddevice/dvbsdffdevice.c
--- vdr-1.7.23/PLUGINS/src/dvbsddevice/dvbsdffdevice.c	2011-08-27 13:33:57.000000000 +0200
+++ vdr-1.7.24/PLUGINS/src/dvbsddevice/dvbsdffdevice.c	2012-02-15 14:15:05.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: dvbsdffdevice.c 2.30 2011/08/27 11:33:57 kls Exp $
+ * $Id: dvbsdffdevice.c 2.31 2012/02/15 13:15:05 kls Exp $
  */
 
 #include "dvbsdffdevice.h"
@@ -66,10 +66,6 @@
         fclose(f);
      }
   devVideoIndex = devVideoOffset >= 0 ? devVideoOffset++ : -1;
-
-  // Video format:
-
-  SetVideoFormat(Setup.VideoFormat);
 }
 
 cDvbSdFfDevice::~cDvbSdFfDevice()
diff -ruN vdr-1.7.23/PLUGINS/src/hello/Makefile vdr-1.7.24/PLUGINS/src/hello/Makefile
--- vdr-1.7.23/PLUGINS/src/hello/Makefile	2011-05-21 14:25:41.000000000 +0200
+++ vdr-1.7.24/PLUGINS/src/hello/Makefile	2012-01-18 13:29:09.000000000 +0100
@@ -1,7 +1,7 @@
 #
 # Makefile for a Video Disk Recorder plugin
 #
-# $Id: Makefile 2.7 2011/05/21 12:25:41 kls Exp $
+# $Id: Makefile 2.8 2012/01/18 12:29:09 kls Exp $
 
 # The official name of this plugin.
 # This name will be used in the '-P...' option of VDR to load the plugin.
@@ -22,9 +22,9 @@
 
 ### The directory environment:
 
-VDRDIR = ../../..
-LIBDIR = ../../lib
-TMPDIR = /tmp
+VDRDIR ?= ../../..
+LIBDIR ?= ../../lib
+TMPDIR ?= /tmp
 
 ### Make sure that necessary options are included:
 
diff -ruN vdr-1.7.23/PLUGINS/src/osddemo/Makefile vdr-1.7.24/PLUGINS/src/osddemo/Makefile
--- vdr-1.7.23/PLUGINS/src/osddemo/Makefile	2011-02-27 11:05:01.000000000 +0100
+++ vdr-1.7.24/PLUGINS/src/osddemo/Makefile	2012-01-18 13:17:23.000000000 +0100
@@ -1,7 +1,7 @@
 #
 # Makefile for a Video Disk Recorder plugin
 #
-# $Id: Makefile 2.3 2011/02/27 10:05:01 kls Exp $
+# $Id: Makefile 2.4 2012/01/18 12:17:23 kls Exp $
 
 # The official name of this plugin.
 # This name will be used in the '-P...' option of VDR to load the plugin.
@@ -20,9 +20,9 @@
 
 ### The directory environment:
 
-VDRDIR = ../../..
-LIBDIR = ../../lib
-TMPDIR = /tmp
+VDRDIR ?= ../../..
+LIBDIR ?= ../../lib
+TMPDIR ?= /tmp
 
 ### Make sure that necessary options are included:
 
@@ -62,7 +62,7 @@
 
 # Dependencies:
 
-MAKEDEP = g++ -MM -MG
+MAKEDEP = $(CXX) -MM -MG
 DEPFILE = .dependencies
 $(DEPFILE): Makefile
 	@$(MAKEDEP) $(DEFINES) $(INCLUDES) $(OBJS:%.o=%.c) > $@
diff -ruN vdr-1.7.23/PLUGINS/src/pictures/HISTORY vdr-1.7.24/PLUGINS/src/pictures/HISTORY
--- vdr-1.7.23/PLUGINS/src/pictures/HISTORY	2012-01-08 14:29:01.000000000 +0100
+++ vdr-1.7.24/PLUGINS/src/pictures/HISTORY	2012-02-17 15:01:48.000000000 +0100
@@ -63,3 +63,7 @@
 2012-01-08:
 
 - Added option -o to pic2mpg.
+
+2012-02-17:
+
+- cReadDir::Next() now skips directory entries "." and "..".
diff -ruN vdr-1.7.23/PLUGINS/src/pictures/Makefile vdr-1.7.24/PLUGINS/src/pictures/Makefile
--- vdr-1.7.23/PLUGINS/src/pictures/Makefile	2011-05-21 14:25:45.000000000 +0200
+++ vdr-1.7.24/PLUGINS/src/pictures/Makefile	2012-01-18 13:30:05.000000000 +0100
@@ -1,7 +1,7 @@
 #
 # Makefile for a Video Disk Recorder plugin
 #
-# $Id: Makefile 2.7 2011/05/21 12:25:45 kls Exp $
+# $Id: Makefile 2.8 2012/01/18 12:30:05 kls Exp $
 
 # The official name of this plugin.
 # This name will be used in the '-P...' option of VDR to load the plugin.
@@ -22,9 +22,9 @@
 
 ### The directory environment:
 
-VDRDIR = ../../..
-LIBDIR = ../../lib
-TMPDIR = /tmp
+VDRDIR ?= ../../..
+LIBDIR ?= ../../lib
+TMPDIR ?= /tmp
 
 ### Make sure that necessary options are included:
 
diff -ruN vdr-1.7.23/PLUGINS/src/pictures/entry.c vdr-1.7.24/PLUGINS/src/pictures/entry.c
--- vdr-1.7.23/PLUGINS/src/pictures/entry.c	2008-02-17 14:42:34.000000000 +0100
+++ vdr-1.7.24/PLUGINS/src/pictures/entry.c	2012-02-17 15:00:28.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: entry.c 2.0 2008/02/17 13:42:34 kls Exp $
+ * $Id: entry.c 2.1 2012/02/17 14:00:28 kls Exp $
  */
 
 #include "entry.h"
@@ -48,13 +48,11 @@
      if (d.Ok()) {
         struct dirent *e;
         while ((e = d.Next()) != NULL) {
-              if (strcmp(e->d_name, ".") && strcmp(e->d_name, "..")) {
-                 struct stat ds;
-                 if (stat(AddDirectory(Directory, e->d_name), &ds) == 0) {
-                    if (!entries)
-                       entries = new cList<cPictureEntry>;
-                    entries->Add(new cPictureEntry(e->d_name, this, S_ISDIR(ds.st_mode)));
-                    }
+              struct stat ds;
+              if (stat(AddDirectory(Directory, e->d_name), &ds) == 0) {
+                 if (!entries)
+                    entries = new cList<cPictureEntry>;
+                 entries->Add(new cPictureEntry(e->d_name, this, S_ISDIR(ds.st_mode)));
                  }
               }
         if (entries)
diff -ruN vdr-1.7.23/PLUGINS/src/pictures/pictures.c vdr-1.7.24/PLUGINS/src/pictures/pictures.c
--- vdr-1.7.23/PLUGINS/src/pictures/pictures.c	2011-02-20 17:50:01.000000000 +0100
+++ vdr-1.7.24/PLUGINS/src/pictures/pictures.c	2012-02-17 15:00:48.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: pictures.c 2.3 2011/02/20 16:50:01 kls Exp $
+ * $Id: pictures.c 2.4 2012/02/17 14:00:48 kls Exp $
  */
 
 #include <getopt.h>
@@ -11,7 +11,7 @@
 #include "menu.h"
 #include "player.h"
 
-static const char *VERSION       = "0.1.0";
+static const char *VERSION       = "0.1.1";
 static const char *DESCRIPTION   = trNOOP("A simple picture viewer");
 static const char *MAINMENUENTRY = trNOOP("Pictures");
 
diff -ruN vdr-1.7.23/PLUGINS/src/servicedemo/Makefile vdr-1.7.24/PLUGINS/src/servicedemo/Makefile
--- vdr-1.7.23/PLUGINS/src/servicedemo/Makefile	2011-02-27 11:05:04.000000000 +0100
+++ vdr-1.7.24/PLUGINS/src/servicedemo/Makefile	2012-01-18 13:17:23.000000000 +0100
@@ -1,7 +1,7 @@
 #
 # Makefile for a Video Disk Recorder plugin
 #
-# $Id: Makefile 2.3 2011/02/27 10:05:04 kls Exp $
+# $Id: Makefile 2.4 2012/01/18 12:17:23 kls Exp $
 
 # The official name of this plugin.
 # This name will be used in the '-P...' option of VDR to load the plugin.
@@ -22,9 +22,9 @@
 
 ### The directory environment:
 
-VDRDIR = ../../..
-LIBDIR = ../../lib
-TMPDIR = /tmp
+VDRDIR ?= ../../..
+LIBDIR ?= ../../lib
+TMPDIR ?= /tmp
 
 ### Make sure that necessary options are included:
 
@@ -64,7 +64,7 @@
 
 # Dependencies:
 
-MAKEDEP = g++ -MM -MG
+MAKEDEP = $(CXX) -MM -MG
 DEPFILE = .dependencies
 $(DEPFILE): Makefile
 	@$(MAKEDEP) $(DEFINES) $(INCLUDES) $(OBJS:%.o=%.c) > $@
diff -ruN vdr-1.7.23/PLUGINS/src/skincurses/Makefile vdr-1.7.24/PLUGINS/src/skincurses/Makefile
--- vdr-1.7.23/PLUGINS/src/skincurses/Makefile	2011-05-21 14:25:49.000000000 +0200
+++ vdr-1.7.24/PLUGINS/src/skincurses/Makefile	2012-01-18 13:30:52.000000000 +0100
@@ -1,7 +1,7 @@
 #
 # Makefile for a Video Disk Recorder plugin
 #
-# $Id: Makefile 2.7 2011/05/21 12:25:49 kls Exp $
+# $Id: Makefile 2.8 2012/01/18 12:30:52 kls Exp $
 
 # The official name of this plugin.
 # This name will be used in the '-P...' option of VDR to load the plugin.
@@ -22,9 +22,9 @@
 
 ### The directory environment:
 
-VDRDIR = ../../..
-LIBDIR = ../../lib
-TMPDIR = /tmp
+VDRDIR ?= ../../..
+LIBDIR ?= ../../lib
+TMPDIR ?= /tmp
 
 ### Make sure that necessary options are included:
 
diff -ruN vdr-1.7.23/PLUGINS/src/status/Makefile vdr-1.7.24/PLUGINS/src/status/Makefile
--- vdr-1.7.23/PLUGINS/src/status/Makefile	2011-02-27 11:05:08.000000000 +0100
+++ vdr-1.7.24/PLUGINS/src/status/Makefile	2012-01-18 13:17:23.000000000 +0100
@@ -1,7 +1,7 @@
 #
 # Makefile for a Video Disk Recorder plugin
 #
-# $Id: Makefile 2.3 2011/02/27 10:05:08 kls Exp $
+# $Id: Makefile 2.4 2012/01/18 12:17:23 kls Exp $
 
 # The official name of this plugin.
 # This name will be used in the '-P...' option of VDR to load the plugin.
@@ -20,9 +20,9 @@
 
 ### The directory environment:
 
-VDRDIR = ../../..
-LIBDIR = ../../lib
-TMPDIR = /tmp
+VDRDIR ?= ../../..
+LIBDIR ?= ../../lib
+TMPDIR ?= /tmp
 
 ### Make sure that necessary options are included:
 
@@ -62,7 +62,7 @@
 
 # Dependencies:
 
-MAKEDEP = g++ -MM -MG
+MAKEDEP = $(CXX) -MM -MG
 DEPFILE = .dependencies
 $(DEPFILE): Makefile
 	@$(MAKEDEP) $(DEFINES) $(INCLUDES) $(OBJS:%.o=%.c) > $@
diff -ruN vdr-1.7.23/PLUGINS/src/svdrpdemo/Makefile vdr-1.7.24/PLUGINS/src/svdrpdemo/Makefile
--- vdr-1.7.23/PLUGINS/src/svdrpdemo/Makefile	2011-02-27 11:05:10.000000000 +0100
+++ vdr-1.7.24/PLUGINS/src/svdrpdemo/Makefile	2012-01-18 13:17:23.000000000 +0100
@@ -1,7 +1,7 @@
 #
 # Makefile for a Video Disk Recorder plugin
 #
-# $Id: Makefile 2.3 2011/02/27 10:05:10 kls Exp $
+# $Id: Makefile 2.4 2012/01/18 12:17:23 kls Exp $
 
 # The official name of this plugin.
 # This name will be used in the '-P...' option of VDR to load the plugin.
@@ -20,9 +20,9 @@
 
 ### The directory environment:
 
-VDRDIR = ../../..
-LIBDIR = ../../lib
-TMPDIR = /tmp
+VDRDIR ?= ../../..
+LIBDIR ?= ../../lib
+TMPDIR ?= /tmp
 
 ### Make sure that necessary options are included:
 
diff -ruN vdr-1.7.23/config.h vdr-1.7.24/config.h
--- vdr-1.7.23/config.h	2012-01-14 14:03:53.000000000 +0100
+++ vdr-1.7.24/config.h	2012-01-16 10:50:03.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.h 2.39 2012/01/14 13:03:53 kls Exp $
+ * $Id: config.h 2.40 2012/01/16 09:50:03 kls Exp $
  */
 
 #ifndef __CONFIG_H
@@ -22,13 +22,13 @@
 
 // VDR's own version number:
 
-#define VDRVERSION  "1.7.23"
-#define VDRVERSNUM   10723  // Version * 10000 + Major * 100 + Minor
+#define VDRVERSION  "1.7.24"
+#define VDRVERSNUM   10724  // Version * 10000 + Major * 100 + Minor
 
 // The plugin API's version number:
 
-#define APIVERSION  "1.7.23"
-#define APIVERSNUM   10723  // Version * 10000 + Major * 100 + Minor
+#define APIVERSION  "1.7.24"
+#define APIVERSNUM   10724  // Version * 10000 + Major * 100 + Minor
 
 // When loading plugins, VDR searches them by their APIVERSION, which
 // may be smaller than VDRVERSION in case there have been no changes to
diff -ruN vdr-1.7.23/cutter.c vdr-1.7.24/cutter.c
--- vdr-1.7.23/cutter.c	2011-12-04 13:55:53.000000000 +0100
+++ vdr-1.7.24/cutter.c	2012-02-16 13:08:39.000000000 +0100
@@ -4,10 +4,11 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: cutter.c 2.10 2011/12/04 12:55:53 kls Exp $
+ * $Id: cutter.c 2.11 2012/02/16 12:08:39 kls Exp $
  */
 
 #include "cutter.h"
+#include "menu.h"
 #include "recording.h"
 #include "remux.h"
 #include "videodir.h"
@@ -197,7 +198,8 @@
 // --- cCutter ---------------------------------------------------------------
 
 cMutex cCutter::mutex;
-char *cCutter::editedVersionName = NULL;
+cString cCutter::originalVersionName;
+cString cCutter::editedVersionName;
 cCuttingThread *cCutter::cuttingThread = NULL;
 bool cCutter::error = false;
 bool cCutter::ended = false;
@@ -208,6 +210,7 @@
   if (!cuttingThread) {
      error = false;
      ended = false;
+     originalVersionName = FileName;
      cRecording Recording(FileName);
 
      cMarks FromMarks;
@@ -229,7 +232,7 @@
            }
         free(s);
         // XXX
-        editedVersionName = strdup(evn);
+        editedVersionName = evn;
         Recording.WriteInfo();
         Recordings.AddByName(editedVersionName, false);
         cuttingThread = new cCuttingThread(FileName, editedVersionName);
@@ -246,27 +249,29 @@
   const char *Error = cuttingThread ? cuttingThread->Error() : NULL;
   delete cuttingThread;
   cuttingThread = NULL;
-  if ((Interrupted || Error) && editedVersionName) {
+  if ((Interrupted || Error) && *editedVersionName) {
      if (Interrupted)
         isyslog("editing process has been interrupted");
      if (Error)
         esyslog("ERROR: '%s' during editing process", Error);
-     RemoveVideoFile(editedVersionName); //XXX what if this file is currently being replayed?
+     if (cReplayControl::NowReplaying() && strcmp(cReplayControl::NowReplaying(), editedVersionName) == 0)
+        cControl::Shutdown();
+     RemoveVideoFile(editedVersionName);
      Recordings.DelByName(editedVersionName);
      }
 }
 
-bool cCutter::Active(void)
+bool cCutter::Active(const char *FileName)
 {
   cMutexLock MutexLock(&mutex);
   if (cuttingThread) {
      if (cuttingThread->Active())
-        return true;
+        return !FileName || strcmp(FileName, originalVersionName) == 0 || strcmp(FileName, editedVersionName) == 0;
      error = cuttingThread->Error();
      Stop();
      if (!error)
         cRecordingUserCommand::InvokeCommand(RUC_EDITEDRECORDING, editedVersionName);
-     free(editedVersionName);
+     originalVersionName = NULL;
      editedVersionName = NULL;
      ended = true;
      }
diff -ruN vdr-1.7.23/cutter.h vdr-1.7.24/cutter.h
--- vdr-1.7.23/cutter.h	2010-08-29 15:32:33.000000000 +0200
+++ vdr-1.7.24/cutter.h	2012-02-16 13:05:33.000000000 +0100
@@ -4,27 +4,32 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: cutter.h 2.2 2010/08/29 13:32:33 kls Exp $
+ * $Id: cutter.h 2.3 2012/02/16 12:05:33 kls Exp $
  */
 
 #ifndef __CUTTER_H
 #define __CUTTER_H
 
 #include "thread.h"
+#include "tools.h"
 
 class cCuttingThread;
 
 class cCutter {
 private:
   static cMutex mutex;
-  static char *editedVersionName;
+  static cString originalVersionName;
+  static cString editedVersionName;
   static cCuttingThread *cuttingThread;
   static bool error;
   static bool ended;
 public:
   static bool Start(const char *FileName);
   static void Stop(void);
-  static bool Active(void);
+  static bool Active(const char *FileName = NULL);
+         ///< Returns true if the cutter is currently active.
+         ///< If a FileName is given, true is only returned if either the
+         ///< original or the edited file name is equal to FileName.
   static bool Error(void);
   static bool Ended(void);
   };
diff -ruN vdr-1.7.23/device.c vdr-1.7.24/device.c
--- vdr-1.7.23/device.c	2011-10-16 16:36:43.000000000 +0200
+++ vdr-1.7.24/device.c	2012-02-15 14:15:19.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.c 2.44 2011/10/16 14:36:43 kls Exp $
+ * $Id: device.c 2.49 2012/02/15 13:15:19 kls Exp $
  */
 
 #include "device.h"
@@ -41,7 +41,8 @@
 
 void cLiveSubtitle::Receive(uchar *Data, int Length)
 {
-  cDevice::PrimaryDevice()->PlayTs(Data, Length);
+  if (cDevice::PrimaryDevice())
+     cDevice::PrimaryDevice()->PlayTs(Data, Length);
 }
 
 // --- cDeviceHook -----------------------------------------------------------
@@ -81,8 +82,6 @@
 
   SetDescription("receiver on device %d", CardIndex() + 1);
 
-  SetVideoFormat(Setup.VideoFormat);
-
   mute = false;
   volume = Setup.CurrentVolume;
 
@@ -270,7 +269,7 @@
           if (NumUsableSlots && !CamSlots.Get(j)->Assign(device[i], true))
              continue; // CAM slot can't be used with this device
           bool ndr;
-          if (device[i]->ProvidesChannel(Channel, Priority, &ndr)) { // this device is basicly able to do the job
+          if (device[i]->ProvidesChannel(Channel, (LiveView && device[i]->IsPrimaryDevice()) ? Setup.PrimaryLimit : Priority, &ndr)) { // this device is basicly able to do the job
              if (NumUsableSlots && device[i]->CamSlot() && device[i]->CamSlot() != CamSlots.Get(j))
                 ndr = true; // using a different CAM slot requires detaching receivers
              // Put together an integer number that reflects the "impact" using
@@ -335,6 +334,7 @@
 
 void cDevice::Shutdown(void)
 {
+  deviceHooks.Clear();
   primaryDevice = NULL;
   for (int i = 0; i < numDevices; i++) {
       delete device[i];
@@ -531,6 +531,14 @@
   return false;
 }
 
+void cDevice::DelLivePids(void)
+{
+  for (int i = ptAudio; i < ptOther; i++) {
+      if (pidHandles[i].pid)
+         DelPid(pidHandles[i].pid, ePidType(i));
+      }
+}
+
 void cDevice::StartSectionHandler(void)
 {
   if (!sectionHandler) {
